<template>
  <!-- FIXME() have a different component for each type of param. -->
  <input
    v-if="parameter.type === 'string+inputmask+text'"
    v-model="$v[parameter.key].$model"
    v-debounce:1s="updateInput"
    :placeholder="parameter.placeholder"
    data-cy="input-string-parameter"
    v-bind="addProperties(parameter, HTMLInputElement)"
    class="form-control sce-param-value-type-string"
    :class="{ 'is-invalid': $v[parameter.key].$invalid }"
    type="text"
    debounce-events="input"
    :disabled="disabled"
  />
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
    validations: {
      type: Function,
      default: () => ({}),
    },
    changeStateScenario: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      HTMLInputElement: null,
      [this.parameter.key]: '',
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
  },
  watch: {
    // Changes on the action
    param() {
      this[this.parameter.key] = this.getParamValue();
    },
  },
  mounted() {
    this.HTMLInputElement = HTMLInputElement;
    if (this.$v[this.parameter.key].$invalid) {
      this.changeStateScenario(this.parameter.key, true);
    }
  },
  beforeMount() {
    this[this.parameter.key] = this.getParamValue();
  },
  validations() {
    return this.validations(this.parameter);
  },
  methods: {
    getParamValue() {
      let value = '';
      if (this.param.value != null && this.param.value !== undefined) {
        value = this.param.value;
      } else if (this.param.default) {
        value = this.param.default;
      }
      return value;
    },
    async updateInput(value, event) {
      if (this.disabled) return;
      if (!this.$v[this.parameter.key].$error) {
        this.changeStateScenario(this.parameter.key, false);
        await this.updateValue(this.parameter.key, event.target.value);
      } else {
        this.changeStateScenario(this.parameter.key, true);
      }
    },
  },
};
</script>
